#pragma once

namespace gc {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{

	public: GraphDoc^ gd;
	public: GraphView^ gv;		 

	public:
		Form1(void)
		{
			// Order is strainge, but otherwise the menu space is overwrapped.

			gd = gcnew GraphDoc();
			gv = gcnew GraphView();

			this->Controls->Add(this->gv);

			InitializeComponent();

			//
			//TODO: Add the constructor code here
			//
			gv->pGraph = gd->pGraph;
		}

		Form1(String^ filename, int nt)
		{
			// Order is strainge, but otherwise the menu space is overwrapped.

			gd = gcnew GraphDoc();
			gv = gcnew GraphView();

			this->Controls->Add(this->gv);

			InitializeComponent();

			//
			//TODO: Add the constructor code here
			//
			gv->pGraph = gd->pGraph;
			gd->OpenFile(filename, nt);
		}



	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}

	private: System::Windows::Forms::MenuStrip^  menuStrip1;
	protected: 
	private: System::Windows::Forms::ToolStripMenuItem^  fileToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  openToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  exitToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  colorToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  setColorToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  multiColorToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  modeToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  plotmodeBoxToolStripMenuItem;





	protected: 

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->menuStrip1 = (gcnew System::Windows::Forms::MenuStrip());
			this->fileToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->openToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->exitToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->colorToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->setColorToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->multiColorToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->modeToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->plotmodeBoxToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuStrip1->SuspendLayout();
			this->SuspendLayout();
			// 
			// menuStrip1
			// 
			this->menuStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {this->fileToolStripMenuItem, 
				this->colorToolStripMenuItem, this->modeToolStripMenuItem});
			this->menuStrip1->Location = System::Drawing::Point(0, 0);
			this->menuStrip1->Name = L"menuStrip1";
			this->menuStrip1->Size = System::Drawing::Size(720, 24);
			this->menuStrip1->TabIndex = 0;
			this->menuStrip1->Text = L"menuStrip1";
			// 
			// fileToolStripMenuItem
			// 
			this->fileToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->openToolStripMenuItem, 
				this->exitToolStripMenuItem});
			this->fileToolStripMenuItem->Name = L"fileToolStripMenuItem";
			this->fileToolStripMenuItem->Size = System::Drawing::Size(36, 20);
			this->fileToolStripMenuItem->Text = L"&File";
			// 
			// openToolStripMenuItem
			// 
			this->openToolStripMenuItem->Name = L"openToolStripMenuItem";
			this->openToolStripMenuItem->Size = System::Drawing::Size(152, 22);
			this->openToolStripMenuItem->Text = L"&Open";
			this->openToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::openToolStripMenuItem_Click);
			// 
			// exitToolStripMenuItem
			// 
			this->exitToolStripMenuItem->Name = L"exitToolStripMenuItem";
			this->exitToolStripMenuItem->Size = System::Drawing::Size(152, 22);
			this->exitToolStripMenuItem->Text = L"E&xit";
			this->exitToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::exitToolStripMenuItem_Click);
			// 
			// colorToolStripMenuItem
			// 
			this->colorToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->setColorToolStripMenuItem, 
				this->multiColorToolStripMenuItem});
			this->colorToolStripMenuItem->Name = L"colorToolStripMenuItem";
			this->colorToolStripMenuItem->Size = System::Drawing::Size(44, 20);
			this->colorToolStripMenuItem->Text = L"&Color";
			// 
			// setColorToolStripMenuItem
			// 
			this->setColorToolStripMenuItem->Name = L"setColorToolStripMenuItem";
			this->setColorToolStripMenuItem->Size = System::Drawing::Size(152, 22);
			this->setColorToolStripMenuItem->Text = L"Set&Color";
			// 
			// multiColorToolStripMenuItem
			// 
			this->multiColorToolStripMenuItem->Name = L"multiColorToolStripMenuItem";
			this->multiColorToolStripMenuItem->Size = System::Drawing::Size(152, 22);
			this->multiColorToolStripMenuItem->Text = L"&MultiColor";
			this->multiColorToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::multiColorToolStripMenuItem_Click);
			// 
			// modeToolStripMenuItem
			// 
			this->modeToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) {this->plotmodeBoxToolStripMenuItem});
			this->modeToolStripMenuItem->Name = L"modeToolStripMenuItem";
			this->modeToolStripMenuItem->Size = System::Drawing::Size(44, 20);
			this->modeToolStripMenuItem->Text = L"&Mode";
			// 
			// plotmodeBoxToolStripMenuItem
			// 
			this->plotmodeBoxToolStripMenuItem->Name = L"plotmodeBoxToolStripMenuItem";
			this->plotmodeBoxToolStripMenuItem->Size = System::Drawing::Size(152, 22);
			this->plotmodeBoxToolStripMenuItem->Text = L"&XY-plot";
			this->plotmodeBoxToolStripMenuItem->Click += gcnew System::EventHandler(this, &Form1::plotmodeBoxToolStripMenuItem_Click);
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(720, 415);
			this->Controls->Add(this->menuStrip1);
			this->MainMenuStrip = this->menuStrip1;
			this->Name = L"Form1";
			this->Text = L"Form1";
			this->SizeChanged += gcnew System::EventHandler(this, &Form1::Form1_SizeChanged);
			this->KeyDown += gcnew System::Windows::Forms::KeyEventHandler(this, &Form1::Form1_KeyDown);
			this->menuStrip1->ResumeLayout(false);
			this->menuStrip1->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

		//----------------------------------------------
		//
		//         Event handlers
		//
		//

	private: System::Void exitToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) 
			 {
				 Application::Exit();

				 //			if(MessageBox::Show("Do you want to exit?", "Graph", MessageBoxButtons::YesNo,
				 //				MessageBoxIcon::Question) == ::DialogResult::Yes){
				 //					Application::Exit();
				 //			}
			 }
	private: System::Void openToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) 
			 {
				 gd->OpenFile(nullptr, 0);
				 gv->Invalidate();
			 }

	private: System::Void plotmodeBoxToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) 
			 {
				 gv->ChangeMode();
				 gv->Invalidate();
			 }

	private: System::Void multiColorToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e)
			 {
				 gv->ChangeColorMode();
				 gv->Invalidate();
			 }

	private: System::Void Form1_SizeChanged(System::Object^  sender, System::EventArgs^  e) 
			 {
				 gv->Invalidate();
			 }

	private: System::Void Form1_KeyDown(System::Object^  sender, System::Windows::Forms::KeyEventArgs^  e) 
			 {
				 if ( e->Control && e->KeyCode == Keys::A ){
					 gv->FullWaves();
					 gv->Invalidate();
				 }
			 }


	};  // end of class
}// end of namespace

