#pragma once


namespace gc {

using namespace System;

    ref class Wave{
	public:
		Wave(){};
		~Wave(){};

	public:
        int npts;
		array<double>^ A;
//		int iStart;
//		int iEnd;
		double aMax;
		double aMin;
		bool visible;
	};



	ref class CGraph : public Object
	{
	public:
		CGraph(void);
	protected:
		~CGraph(void);

	public:

		int ntraces;
		int nwaves;   // = ntrances + 1

		int npts;

		array<Wave^>^ W;
		int XAxisNo;

		String^ xLabel;
		String^ yLabel;

		int XPStart;         // the first displayed point
		int XPEnd;
		int Points;         // number of displayed points
		double XOrigin;     // starting x value
		double XDelta;      // x increment
		double XMin;        // limits of graph
		double XMax;
		double YMin;
		double YMax;
		double TheYMin;
		double TheYMax;

		int MakeWaves(void);
		void FindMinMax();
		void FullGraph();
		void findXRange(double lower, double upper);

	};
}