#pragma once

namespace gc {

	using namespace System;
	using namespace System::Windows::Forms;
	using namespace System::Drawing;

	ref class Form1;

	public ref class GraphView : public System::Windows::Forms::Panel
	{

	public:
		GraphView(void);
	protected:
		~GraphView();
	private: 

		void InitializeComponent(void);
		void GraphView_Paint(System::Object^  sender, System::Windows::Forms::PaintEventArgs^  e) ;
		void GraphView_MouseDown(System::Object^ sender, System::Windows::Forms::MouseEventArgs^ e);
		void GraphView_MouseUp(System::Object^ sender, System::Windows::Forms::MouseEventArgs^ e);
		void GraphView_MouseMove(System::Object^ sender, System::Windows::Forms::MouseEventArgs^ e);


	public:
		CGraph^ pGraph;

	protected:
		bool penDownFlag;
		bool lineDrawn;
		Point originPoint,endPoint;

		Point startPoint;
		Rectangle theRectangle;

		double cXScaleFactor;
		double cYScaleFactor;

		int cXOffset;
		int cYOffset;
		double rXMin;
		double rXMax;
		double rYMin;
		double rYMax;

		bool m_bMultiColor;

	public:
		int cXScale( double x );
		int cYScale( double y);
		double AutoRange(double ZMin,double ZMax);
		double cXScaleBack( int ix);
		double cYScaleBack( int iy);
		int cXScaleBackInt(int ix);
		void DrawTrace(Graphics^ g);
		void FullWaves(); 


		void ChangeMode();
		void ChangeColorMode();

	};
}