//
// gc.cpp : main project file.
//
//  Application for simple graph drawing 
// 
//  Transported from MFC version
//  Some of the features are not incorporated
//    for example, change color, axis labels, printing 
//
//
//  Author 
//       Keiji Imoto
//       Department of Information Physiology  
//       National Instutite for Physiological Sciences
//       Okazaki 444-8787, Japan 
//
//  Version hisotry
//       11-Jan-2006 version 1.0.0.1
//       25-Jun-2008 text data files are now readable  
//       02-Jul-2008 multi-color mode is added
//
//  Known bugs
//        11-Jan-2006
//            * Crashes when the number of points is below 1 or 2 ?
//
//
//  Copyright (C) 2006, 2008 NIPS
//

#include "stdafx.h"

using namespace System;
using namespace System::IO;
using namespace gc;

[STAThreadAttribute]
int main(array<System::String ^> ^args)
{
	// Enabling Windows XP visual effects before any controls are created
	Application::EnableVisualStyles();
	Application::SetCompatibleTextRenderingDefault(false); 

	// Create the main window and run it

	if(args->Length==0){
		Application::Run(gcnew Form1());
		return 0;
	}else if (args->Length ==1 ){
		if( File::Exists(args[0]) != true) return 0;
		Application::Run(gcnew Form1(args[0],0));
	}else if (args->Length ==2 ){
		if( File::Exists(args[0]) != true) return 0;

		int nt;
		try{
			nt=Int32::Parse(args[1]);
		}catch (FormatException^ /*e*/){
			return 0;
		}
		if(nt>0) Application::Run(gcnew Form1(args[0],Int32::Parse(args[1])));
	}
	return 0;
}
